var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, TemplateRef, forwardRef } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { RebirthUIConfig } from '../rebirth-ui.config';
var AutoCompletePopupComponent = AutoCompletePopupComponent_1 = (function () {
    function AutoCompletePopupComponent(rebirthUIConfig) {
        this.rebirthUIConfig = rebirthUIConfig;
        this.activeIndex = 0;
        this.onChange = function (_) { return null; };
        this.onTouched = function () { return null; };
        this.formatter = rebirthUIConfig.autoComplete.formatter;
    }
    AutoCompletePopupComponent.prototype.writeValue = function (obj) {
        this.value = obj;
    };
    AutoCompletePopupComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    AutoCompletePopupComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    AutoCompletePopupComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    AutoCompletePopupComponent.prototype.onSelect = function (item) {
        this.value = item;
        this.onTouched();
        this.onChange(this.value);
    };
    AutoCompletePopupComponent.prototype.selectCurrentItem = function () {
        if (this.source && this.source.length) {
            this.onSelect(this.source[this.activeIndex]);
        }
    };
    AutoCompletePopupComponent.prototype.onActiveIndexChange = function (index) {
        this.activeIndex = index;
    };
    AutoCompletePopupComponent.prototype.reset = function () {
        this.activeIndex = 0;
    };
    AutoCompletePopupComponent.prototype.next = function () {
        if (this.isOpen && this.source && this.source.length) {
            if (this.activeIndex === this.source.length - 1) {
                this.activeIndex = 0;
                return;
            }
            this.activeIndex = this.activeIndex + 1;
        }
    };
    AutoCompletePopupComponent.prototype.prev = function () {
        if (this.isOpen && this.source && this.source.length) {
            if (this.activeIndex === 0) {
                this.activeIndex = this.source.length - 1;
                return;
            }
            this.activeIndex = this.activeIndex - 1;
        }
    };
    return AutoCompletePopupComponent;
}());
__decorate([
    Input(),
    __metadata("design:type", String)
], AutoCompletePopupComponent.prototype, "cssClass", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], AutoCompletePopupComponent.prototype, "disabled", void 0);
__decorate([
    Input(),
    __metadata("design:type", Array)
], AutoCompletePopupComponent.prototype, "source", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], AutoCompletePopupComponent.prototype, "isOpen", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], AutoCompletePopupComponent.prototype, "term", void 0);
__decorate([
    Input(),
    __metadata("design:type", TemplateRef)
], AutoCompletePopupComponent.prototype, "itemTemplate", void 0);
__decorate([
    Input(),
    __metadata("design:type", TemplateRef)
], AutoCompletePopupComponent.prototype, "noResultItemTemplate", void 0);
__decorate([
    Input(),
    __metadata("design:type", Function)
], AutoCompletePopupComponent.prototype, "formatter", void 0);
AutoCompletePopupComponent = AutoCompletePopupComponent_1 = __decorate([
    Component({
        selector: 're-auto-complete-popup',
        template: "\n    <template #defaultItemTemplate let-item=\"item\" let-term=\"term\">\n      <re-hightlight [value]=\"formatter(item)\" [term]=\"term\"></re-hightlight>\n    </template>\n\n    <ul class=\"list-unstyled\">\n      <li *ngFor=\"let item of source; let $index = index;\" class=\"dropdown-item\"\n          [ngClass]=\"{'bg-primary': $index == activeIndex}\" (click)=\"onSelect(item)\"\n          (mouseenter)=\"onActiveIndexChange($index)\">\n        <template [ngTemplateOutlet]=\"itemTemplate || defaultItemTemplate\"\n                  [ngOutletContext]=\"{ formatter: formatter, term:term, source:source, item:item, $index:$index}\"></template>\n      </li>\n      <li class=\"dropdown-item\" *ngIf=\"!source?.length && noResultItemTemplate\">\n        <template [ngTemplateOutlet]=\"noResultItemTemplate\"\n                  [ngOutletContext]=\"{ term:term, source:source}\"></template>\n      </li>\n    </ul>\n  ",
        host: {
            '[class]': '"dropdown-menu "  +  (cssClass ? cssClass : "")',
            '[style.display]': 'isOpen && (source?.length || noResultItemTemplate) ? "inline-block" : "none"'
        },
        styles: ["\n    .dropdown-item{display:block;width:100%;padding:8px 1rem;clear:both;white-space:nowrap;border:0}\n  "],
        providers: [{
                provide: NG_VALUE_ACCESSOR,
                useExisting: forwardRef(function () { return AutoCompletePopupComponent_1; }),
                multi: true
            }]
    }),
    __metadata("design:paramtypes", [RebirthUIConfig])
], AutoCompletePopupComponent);
export { AutoCompletePopupComponent };
var AutoCompletePopupComponent_1;
//# sourceMappingURL=auto-complete-popup.component.js.map