var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, TemplateRef, forwardRef, ViewChild, ChangeDetectorRef } from '@angular/core';
import { AutoCompleteDirective } from './auto-complete.directive';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { RebirthUIConfig } from '../rebirth-ui.config';
var MutipleAutoCompleteComponent = MutipleAutoCompleteComponent_1 = (function () {
    function MutipleAutoCompleteComponent(rebirthUIConfig, changeDetectorRef) {
        this.rebirthUIConfig = rebirthUIConfig;
        this.changeDetectorRef = changeDetectorRef;
        this.appendBody = false;
        this.onChange = function (_) { return null; };
        this.onTouched = function () { return null; };
        this.delay = rebirthUIConfig.autoComplete.delay;
        this.minLength = rebirthUIConfig.autoComplete.minLength;
        this.itemTemplate = rebirthUIConfig.autoComplete.itemTemplate;
        this.noResultItemTemplate = rebirthUIConfig.autoComplete.noResultItemTemplate;
        this.formatter = rebirthUIConfig.autoComplete.formatter;
        this.valueParser = rebirthUIConfig.autoComplete.valueParser;
    }
    MutipleAutoCompleteComponent.prototype.writeValue = function (obj) {
        this.mutipleItems = obj || [];
        this.changeDetectorRef.markForCheck();
    };
    MutipleAutoCompleteComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    MutipleAutoCompleteComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    MutipleAutoCompleteComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    MutipleAutoCompleteComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (this.autoCompleteDirective) {
            this.autoCompleteDirective.registerOnTouched(function () { return _this.onTouched(); });
        }
    };
    MutipleAutoCompleteComponent.prototype.toggle = function ($event) {
        if (this.autoCompleteDirective) {
            this.autoCompleteDirective.toggle($event);
        }
    };
    MutipleAutoCompleteComponent.prototype.onMutipleSearch = function () {
        this.onTouched();
        if (this.mutipleItems.indexOf(this.selectValue) === -1) {
            this.mutipleItems.push(this.selectValue);
            this.onChange(this.mutipleItems);
        }
        this.selectValue = '';
    };
    MutipleAutoCompleteComponent.prototype.removeLabel = function (label) {
        if (this.disabled) {
            return;
        }
        this.onTouched();
        if (this.mutipleItems.indexOf(label) !== -1) {
            this.mutipleItems = this.mutipleItems.filter(function (item) { return item !== label; });
            this.onChange(this.mutipleItems);
        }
    };
    MutipleAutoCompleteComponent.prototype.onMutipleSearchBoxBackspace = function ($event) {
        var _this = this;
        this.onTouched();
        if (!$event.target.value && this.mutipleItems.length) {
            this.mutipleItems.pop();
            this.onChange(this.mutipleItems);
            setTimeout(function () { return _this.autoCompleteDirective.positionPopup(); }, 0);
        }
    };
    return MutipleAutoCompleteComponent;
}());
__decorate([
    Input(),
    __metadata("design:type", String)
], MutipleAutoCompleteComponent.prototype, "id", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], MutipleAutoCompleteComponent.prototype, "disabled", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], MutipleAutoCompleteComponent.prototype, "cssClass", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], MutipleAutoCompleteComponent.prototype, "popupCssClass", void 0);
__decorate([
    Input(),
    __metadata("design:type", Number)
], MutipleAutoCompleteComponent.prototype, "delay", void 0);
__decorate([
    Input(),
    __metadata("design:type", Number)
], MutipleAutoCompleteComponent.prototype, "minLength", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], MutipleAutoCompleteComponent.prototype, "appendBody", void 0);
__decorate([
    Input(),
    __metadata("design:type", Array)
], MutipleAutoCompleteComponent.prototype, "dataSource", void 0);
__decorate([
    Input(),
    __metadata("design:type", TemplateRef)
], MutipleAutoCompleteComponent.prototype, "itemTemplate", void 0);
__decorate([
    Input(),
    __metadata("design:type", TemplateRef)
], MutipleAutoCompleteComponent.prototype, "noResultItemTemplate", void 0);
__decorate([
    Input(),
    __metadata("design:type", Function)
], MutipleAutoCompleteComponent.prototype, "formatter", void 0);
__decorate([
    Input(),
    __metadata("design:type", Function)
], MutipleAutoCompleteComponent.prototype, "valueParser", void 0);
__decorate([
    Input(),
    __metadata("design:type", Function)
], MutipleAutoCompleteComponent.prototype, "onSearch", void 0);
__decorate([
    ViewChild(AutoCompleteDirective),
    __metadata("design:type", AutoCompleteDirective)
], MutipleAutoCompleteComponent.prototype, "autoCompleteDirective", void 0);
MutipleAutoCompleteComponent = MutipleAutoCompleteComponent_1 = __decorate([
    Component({
        selector: 're-mutiple-auto-complete',
        template: "\n    <label for=\"mutiple-label-auto-complete-{{id}}\" class=\"mutiple-label-auto-complete {{cssClass}}\">\n      <ul>\n        <li *ngFor=\"let item of mutipleItems\">\n                  <span class=\"label label-info\" [ngClass]=\"{disabled: disabled}\">\n                     <i aria-hidden=\"true\" class=\"label-close\" (click)=\"removeLabel(item)\">&times;</i>{{formatter(item)}}\n                  </span>\n        </li>\n        <li *ngIf=\"!disabled\">\n          <input id=\"mutiple-label-auto-complete-{{id}}\" type=\"text\" name=\"mutipleAutoComplete\"\n                 class=\"auto-complete-control\"\n                 [(ngModel)]=\"selectValue\" (selectValueChange)=\"onMutipleSearch()\" [onSearch]=\"onSearch\"\n                 [cssClass]=\"popupCssClass\" [delay]=\"delay\" [minLength]=\"minLength\" [itemTemplate]=\"itemTemplate\"\n                 [noResultItemTemplate]=\"noResultItemTemplate\" [formatter]=\"formatter\" [valueParser]=\"valueParser\"\n                 (keydown.backspace)=\"onMutipleSearchBoxBackspace($event)\" [disabled]=\"disabled\" [dataSource]=\"dataSource\"\n                 [appendBody]=\"appendBody\" reAutoComplete>\n        </li>\n      </ul>\n    </label>\n  ",
        styles: ["\n    .mutiple-label-auto-complete{padding:0px;font-weight:normal}.mutiple-label-auto-complete ul{display:block;list-style:none;width:100%;padding:2px;background-color:#fff;border:1px solid #ccc;border-radius:4px}.mutiple-label-auto-complete ul:focus{border-color:#66afe9;outline:1px}.mutiple-label-auto-complete ul::-ms-expand{border:0;background-color:transparent}.mutiple-label-auto-complete ul li{display:inline-block;margin:5px}.mutiple-label-auto-complete ul li .label-close{cursor:pointer;margin-right:2px;font-weight:bold;font-size:1.5rem}.mutiple-label-auto-complete ul .auto-complete-control{height:100%;border:none;outline:none}.mutiple-label-auto-complete ul .auto-complete-control :focus{border:none;outline:none}\n  "],
        providers: [{
                provide: NG_VALUE_ACCESSOR,
                useExisting: forwardRef(function () { return MutipleAutoCompleteComponent_1; }),
                multi: true
            }]
    }),
    __metadata("design:paramtypes", [RebirthUIConfig, ChangeDetectorRef])
], MutipleAutoCompleteComponent);
export { MutipleAutoCompleteComponent };
var MutipleAutoCompleteComponent_1;
//# sourceMappingURL=mutiple-auto-complete.component.js.map