var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ChangeDetectionStrategy, Input, HostListener, ChangeDetectorRef, QueryList, EventEmitter } from '@angular/core';
import { DataTableComponent } from './data-table.component';
import { DataTableTmplsComponent } from './tmpl/data-table-tmpls.component';
import { ForceUpdateReason } from './force-update-reason.model';
var DataTableRowComponent = (function () {
    function DataTableRowComponent(dt, changeDetectorRef) {
        this.dt = dt;
        this.changeDetectorRef = changeDetectorRef;
        this.forceUpdateEvent = new EventEmitter();
    }
    DataTableRowComponent.prototype.forceUpdate = function () {
        this.changeDetectorRef.markForCheck();
        this.forceUpdateEvent.emit(ForceUpdateReason.RowUpdate);
    };
    DataTableRowComponent.prototype.onRowClick = function ($event) {
        this.dt.onRowClick({ rowIndex: this.rowIndex, rowItem: this.rowItem, rowComponent: this });
    };
    DataTableRowComponent.prototype.onRowDBClick = function ($event) {
        this.dt.onRowDBClick({ rowIndex: this.rowIndex, rowItem: this.rowItem, rowComponent: this });
    };
    DataTableRowComponent.prototype.onRowCheckChange = function (rowIndex, rowItem) {
        this.dt.onRowCheckChange({ rowItem: rowItem, rowIndex: rowIndex, checked: rowItem.$$checked });
    };
    return DataTableRowComponent;
}());
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], DataTableRowComponent.prototype, "checkable", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], DataTableRowComponent.prototype, "rowItem", void 0);
__decorate([
    Input(),
    __metadata("design:type", Number)
], DataTableRowComponent.prototype, "rowIndex", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], DataTableRowComponent.prototype, "allChecked", void 0);
__decorate([
    Input(),
    __metadata("design:type", QueryList)
], DataTableRowComponent.prototype, "columns", void 0);
__decorate([
    Input(),
    __metadata("design:type", DataTableTmplsComponent)
], DataTableRowComponent.prototype, "dataTableTemplates", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], DataTableRowComponent.prototype, "editModel", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], DataTableRowComponent.prototype, "editRowItem", void 0);
__decorate([
    HostListener('click', ['$event']),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], DataTableRowComponent.prototype, "onRowClick", null);
__decorate([
    HostListener('dblclick', ['$event']),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], DataTableRowComponent.prototype, "onRowDBClick", null);
DataTableRowComponent = __decorate([
    Component({
        selector: 're-data-table-row,[reDataTableRow]',
        template: "\n    <td *ngIf=\"checkable\" class=\"checkable-cell\">\n      <form class=\"form-inline\">\n        <div class=\"form-group\">\n          <div class=\"checkbox\">\n            <label>\n              <input type=\"checkbox\" name=\"rowChecker\" [(ngModel)]=\"rowItem.$checked\"\n                     (change)=\"onRowCheckChange(rowIndex, rowItem)\">\n            </label>\n          </div>\n        </div>\n      </form>\n    </td>\n    <ng-container *ngFor=\"let column of columns; let colIndex = index\">\n      <td reDataTableCell [dataTableTemplates]=\"dataTableTemplates\" [rowIndex]=\"rowIndex\" [colIndex]=\"colIndex\"\n          [column]=\"column\" [rowItem]=\"rowItem\" [style.width]=\"column.width || ''\" [editModel]=\"editModel\"\n          [isEditRow]=\"editRowItem == rowItem\">\n      </td>\n    </ng-container>\n  ",
        host: {
            '[class.table-row-selected]': 'selectable && (rowItem == dt.selectedRowItem)',
        },
        changeDetection: ChangeDetectionStrategy.OnPush,
    }),
    __metadata("design:paramtypes", [DataTableComponent, ChangeDetectorRef])
], DataTableRowComponent);
export { DataTableRowComponent };
//# sourceMappingURL=data-table-row.component.js.map