var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ChangeDetectionStrategy, ContentChild, Input } from '@angular/core';
import { DataTableCellViewTmplComponent } from './data-table-cell-view-tmpl.component';
import { DataTableCellEditTmplComponent } from './data-table-cell-edit-tmpl.component';
import { DataTableCellFilterTmplComponent } from './data-table-cell-filter-tmpl.component';
import { formatDate } from '../../utils/date-utils';
import { RebirthUIConfig } from '../../rebirth-ui.config';
var DataTableColumnTmplComponent = (function () {
    function DataTableColumnTmplComponent(rebirthUIConfig) {
        this.rebirthUIConfig = rebirthUIConfig;
        this.fieldType = 'text';
    }
    Object.defineProperty(DataTableColumnTmplComponent.prototype, "formatter", {
        get: function () {
            return this._formatter || this.defaultFormatter.bind(this);
        },
        set: function (formatter) {
            this._formatter = formatter;
        },
        enumerable: true,
        configurable: true
    });
    // column.extraOptions?.dateFormat
    DataTableColumnTmplComponent.prototype.defaultFormatter = function (item) {
        if (this.fieldType && this[this.fieldType]) {
            return this[this.fieldType](item);
        }
        return item && item.toString();
    };
    DataTableColumnTmplComponent.prototype.date = function (item) {
        var pattern = this.extraOptions && this.extraOptions.dateFormat ?
            this.extraOptions.dateFormat : this.rebirthUIConfig.datePicker.format.date;
        return item ? formatDate(item, pattern) : '';
    };
    DataTableColumnTmplComponent.prototype.datetime = function (item) {
        var pattern = this.extraOptions && this.extraOptions.dateFormat ?
            this.extraOptions.dateFormat : this.rebirthUIConfig.datePicker.format.time;
        return item ? formatDate(item, pattern) : '';
    };
    return DataTableColumnTmplComponent;
}());
__decorate([
    Input(),
    __metadata("design:type", String)
], DataTableColumnTmplComponent.prototype, "fieldType", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], DataTableColumnTmplComponent.prototype, "field", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], DataTableColumnTmplComponent.prototype, "header", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], DataTableColumnTmplComponent.prototype, "sortable", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], DataTableColumnTmplComponent.prototype, "editable", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], DataTableColumnTmplComponent.prototype, "filterable", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], DataTableColumnTmplComponent.prototype, "cellClass", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], DataTableColumnTmplComponent.prototype, "width", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], DataTableColumnTmplComponent.prototype, "extraOptions", void 0);
__decorate([
    ContentChild(DataTableCellViewTmplComponent),
    __metadata("design:type", DataTableCellViewTmplComponent)
], DataTableColumnTmplComponent.prototype, "cellCmp", void 0);
__decorate([
    ContentChild(DataTableCellEditTmplComponent),
    __metadata("design:type", DataTableCellEditTmplComponent)
], DataTableColumnTmplComponent.prototype, "cellEditCmp", void 0);
__decorate([
    ContentChild(DataTableCellFilterTmplComponent),
    __metadata("design:type", DataTableCellFilterTmplComponent)
], DataTableColumnTmplComponent.prototype, "cellFilterCmp", void 0);
__decorate([
    Input(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Function])
], DataTableColumnTmplComponent.prototype, "formatter", null);
DataTableColumnTmplComponent = __decorate([
    Component({
        selector: 're-column',
        template: '',
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [RebirthUIConfig])
], DataTableColumnTmplComponent);
export { DataTableColumnTmplComponent };
//# sourceMappingURL=data-table-column-tmpl.component.js.map